Subject: Re: [PATCHv2 net-next] xfrm: Make xfrm_state timer monotonic

From: Steffen Klassert <[email-masked]>
Date: Tue, 13 Aug 2013 12:59:16 +0200

On Tue, Aug 13, 2013 at 04:37:04PM +0800, Fan Du wrote:
> 
> 
> On 2013年08月13日 15:55, Steffen Klassert wrote:
> >On Mon, Aug 12, 2013 at 01:40:07PM +0800, Fan Du wrote:
> >>
> >>
> >>On 2013年08月06日 17:22, Steffen Klassert wrote:
> >>>On Tue, Aug 06, 2013 at 02:57:05PM +0800, Fan Du wrote:
> >>>>xfrm_state timer should be independent of system clock change,
> >>>>so switch to monotonic clock base.
> >>>>
> >>>
> >>>I think a monotonic timer will reintroduce a bug on suspend/resume
> >>>that was fixed by commit 9e0d57fd6
> >>>(xfrm: SAD entries do not expire correctly after suspend-resume)
> >>>
> >>>Please make sure that this does not happen.
> >>
> >>What about using CLOCK_BOOTTIME? it's monotonic, but includes suspend time as well.
> >
> >As I said, I'm open to everything that fixes your problem and does not
> >introduce a regression. I'll consider applying after some testing
> >if noone else has objections.
> 
> Hi, Steffen
> 
> Thanks for your understanding! :)
> 
> I happened to bump into CLOCK_BOOTTIME several days ago, so apologize for
> eating my words earlier. Changing xfrm_state timer to monotonic does not
> solve the problem I've described earlier in:
> 
> http://www.spinics.net/lists/netdev/msg245019.html (*1*)
> 
> So is there any light of hope for the proposal in (*1*) by using CLOCK_BOOTTIME
> instead?
> 

Well, you have to convince David in the first place, as he is sitting
upstream from me ;)

Also, I think he is right with his complaint. Why not following the
clock_was_set approach you started with?